//--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
// AMMO DISPLAYS FOR CERTAIN WEAPONS
//--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==

#define NORMALHOLDTIME 0.1

#define ANUM_PRIMARY 		ACSBASEID-1
#define ANUM_SECONDARY 		ACSBASEID-2
#define ANUM_BOX			ACSBASEID-3

// -- FOR THE PUMP SHOTGUN -- //
#define SGAMMOTYPES 2
#define AMMO_PIC 0
#define AMMO_INVENTORY 1
#define AMMO_UPGRADE 2
#define AMMO_HUDPIC 3

#define AMMOBARSTART 120.0
#define AMMOBARHEIGHT 28.0

void DrawAmmoTypes(int WI, str GW)
{
	int l, finalVal, tempX, tempY, resX, resY, counter, idCounter;
	int ATC = WeaponList[WI].ammoTypeCount;

	// Does this weapon even have more than one ammo type?
	if (WeaponList[WI].ammoTypeCount <= 0)
		return;

	resX = ScreenWidth();
	resY = ScreenHeight();
	
	tempX = resX - 380.0;
	tempY = resY - 14.0;
	
	// Check all the ammo types
	for (l=0; l<ATC; l++)
	{
		int isThis = false;
		
		str itemName = GW;
		str prefix = WeaponList[WI].ammoTypes[l].Prefix;
		
		if (StrLen(prefix) > 0)
			itemName = StrParam(s:itemName, s:" ", s:prefix);
		
		// We have it!
		if (CheckInventory(itemName))
		{
			// This mode is currently selected
			if (CheckInventory(WeaponList[WI].wheelClass) == l)
				isThis = true;
			
			// Draw the box!
			SetFont(WeaponList[WI].ammoTypes[l].BG);
			HMUSReduxExtended(tempX, tempY - (25.0 * counter), "A", 2, 2, ANUM_BOX - idCounter, 0.06, 1, 0.0, 0);
			idCounter ++;
				
			// Draw the shell!
			SetFont(WeaponList[WI].ammoTypes[l].Icon);
			HMUSReduxExtended(tempX - 118.0, (tempY - (25.0 * counter)) - 12.0, "A", 2, 1, ANUM_BOX - idCounter, 0.06, 1, 0.0, 0);
			idCounter ++;
			
			// Draw the amount
			str colorString = "\cU";
			if (isThis)
				colorString = "\cK";
			str ammoString = StrParam(s:colorString, d:CheckInventory(WeaponList[WI].ammoTypes[l].Class));
				
			SetFont("BIGFONT");
			HMUSReduxExtended(tempX - 107.0, (tempY - (25.0 * counter)) - 12.0, ammoString, 0, 1, ANUM_BOX - idCounter, 0.06, 1, 0.0, 0);
			idCounter ++;
			
			counter ++;
		}
	}
}

//--------------------------------------------------------------
//
// D R A W   M A I N   A M M O   N U M B E R S
//
//--------------------------------------------------------------

script "AmmoNumbers" (void) CLIENTSIDE
{
	int ammoPrimary, ammoSecondary;
	
	while (true)
	{
		int resX = ScreenWidth();
		int resY = ScreenHeight();
		
		if (CheckInventory("UseACSAmmoDisplay") > 0)
		{
			str GW = GetWeapon();
			int WI = WeaponByType( GW );
			ammoPrimary = GetPrimaryAmmo(WI, GW);
			ammoSecondary = GetSecondaryAmmo(WI, GW);
			
			SetFont("HUGEFONT");
			HMUSReduxExtended(resX - 245.0, resY - 120.0, StrParam(d:ammoPrimary), 2, 0, ANUM_PRIMARY, 0.06, 1, 0.0, 0);
			SetFont("TYPEWRIT");
			HMUSReduxExtended(resX - 278.0, resY - 60.0, StrParam(d:ammoSecondary), 2, 0, ANUM_SECONDARY, 0.06, 1, 0.1, 0);
			SetFont("SMALLFONT");
		}
		
		delay(2);
	}
}

// Primary ammo count
int GetPrimaryAmmo(int WI, str GW)
{
	if (WI == -1)
		return 0;
		
	return CheckInventory(WeaponList[WI].ammoClassA);
}

// Secondary ammo count
// This also handles drawing of alternate ammo
int GetSecondaryAmmo(int WI, str GW)
{
	if (WI == -1)
		return 0;
	
	DrawAmmoTypes(WI, GW);
	
	return CheckInventory( GetReserveClass(WI) );
}