#define LAST_TIME 3

str HeadshotActors[2] = { "HeadshotTarget1", "HeadshotTarget1Strong" };
str LegActors[1] = { "LegBoxBase" };

//-------------------------------------------------------------------------
// Called when the actor spawns
// TODO: REMOVE ME
script 625 (int spawnheight, int typetospawn)
{
	/*
	ACS_ExecuteWithResult(626,spawnheight,typetospawn,0,0);
	if (GetActorProperty(0,APROP_Health) > 0)
	{
	delay(LAST_TIME);
	restart;
	}
	*/
}

//-------------------------------------------------------------------------
// Actual headspawn script
//
// Headshot actor will have frame time of LAST_TIME tics, then disappear
// Uses A_Explode
// TODO: REMOVE ME
//-------------------------------------------------------------------------

script 626 (int heighttospawn, int headspawner)
{
	/*
	int x,y,z,angle;
	x = GetActorX(0);
    y = GetActorY(0);
    z = GetActorZ(0) + heighttospawn * 1.0;
	angle = GetActorAngle(0) >> 8;
	Spawn(HeadshotActors[headspawner],x,y,z,0,angle);
	*/
}
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

// Called when the actor spawns
// TODO: REMOVE ME
script "InitiateLegs" (int typetospawn)
{
	/*
	ACS_NamedExecuteWithResult("SpawnLegs",typetospawn,0,0,0);
	if (GetActorProperty(0,APROP_Health) > 0)
	{
	delay(LAST_TIME);
	restart;
	}
	*/
}

//-------------------------------------------------------------------------
// Actual headspawn script
//
// Headshot actor will have frame time of LAST_TIME tics, then disappear
// Uses A_Explode
// TODO: REMOVE ME
//-------------------------------------------------------------------------

script "SpawnLegs" (int legspawner)
{
	/*
	int x,y,z,angle;
	x = GetActorX(0);
    y = GetActorY(0);
    z = GetActorZ(0);
	angle = GetActorAngle(0) >> 8;
	Spawn(LegActors[legspawner],x,y,z,0,angle);
	*/
}
//-------------------------------------------------------------------------

#define HEADSHOT_DAMAGE			50

// Store the player who caused the headshot
int bloodPlayer;

int GetHeadshotDamage(void) 
{ 
	int HSD = HEADSHOT_DAMAGE;
	
	// Set our TID temporarily
	int oldID = ActivatorTID();
	int newID = UniqueTID();
	Thing_ChangeTID(oldID, newID);
	
	SetActivatorToTarget(0);
	
	bloodPlayer = 0;
	
	// Player
	if (ClassifyActor(0) & ACTOR_PLAYER)
	{
		bloodPlayer = ActivatorTID();
		// Which wep are we holding?
		int WI = WeaponByType( GetWeapon() );
		if (WI >= 0)
			HSD = ShaveInt(HSD * WeaponList[WI].headshotMult);
			
		// Perk multiplier
		HSD = ShaveInt(HSD * PerkedHeadshotMult());
	}
	
	SetActivator(newID);
	Thing_ChangeTID(0, oldID);

	return HSD;
}

#define HEAD_CLEANUP_DELAY				5
#define HEAD_STORED						4
struct HeadPosT
{
	bool Occupied;
	int X, Y;
};
private HeadPosT			StoredHeads[HEAD_STORED];
private int					StoredHeadCount;

script "HeadAvailable" ()
{
	bool valid;
	
	int x = GetActorX(0);
	int y = GetActorY(0);
	
	for (int l=0; l<HEAD_STORED; l++)
	{
		if (StoredHeads[l].Occupied)
			continue;
			
		if (abs(StoredHeads[l].X - x) <= 5.0 && abs(StoredHeads[l].Y - y) <= 1.0)
			continue;
			
		StoredHeads[l].Occupied = true;
		StoredHeads[l].X = x;
		StoredHeads[l].Y = y;
		valid = true;
	}
	
	SetResultValue(valid);
}

script "HeadEnsure" OPEN CLIENTSIDE
{
	while (true)
	{
		for (int l=0; l<HEAD_STORED; l++)
			StoredHeads[l].Occupied = false;
			
		delay(HEAD_CLEANUP_DELAY);
	}
}

// Called from blood!
// TODO: AFFECT DAMAGE BY DAMAGE TYPE / WEAPON YOU USE
script "Script_Blood" (int bloodz) // blood's Z is already passed automatically
{
    int ownerz;
	
    // Set activator to blood's owner, and retrieve its Z coord
	// This is the monster you're shooting
   SetActivatorToTarget(0);
   
   // Height of the actual actor
   int aHeight = CheckInventory("RealHeight");
   if (aHeight <= 0)
		aHeight = GetActorProperty(0, APROP_HEIGHT) >> 16;

    if ((ClassifyActor(0) & ACTOR_MONSTER) && !CheckInventory("IgnoreHeadshot"))
    {
		int hlt = GetActorProperty(0, APROP_HEALTH);
        ownerz = GetActorZ(0) >> 16;
		
        int headshotheight = aHeight - 13;
        // int legshotheight = (GetActorProperty(0, APROP_HEIGHT) >> 16) / 4;

		int ZI = ZombieByClass("");
		int HSDamage = GetHeadshotDamage();
		
		// Check zombie list for our headshot multiplier
		if (ZI != -1)
			HSDamage = ShaveInt(HSDamage * ZombieList[ZI].headStrength);
		
		if (GetUserCVar(0, "cl_zombiedebugger"))
		{
			SetFont("TFNDESC");
			PrintBold(s:"\cD- HEADSHOT! -\nZ: ", d:bloodz, s:" / ", d:headshotheight, s:"\n", d:HSDamage, s:" DAMAGE\n",
				s:"HEALTH: ", d:hlt, s:" -> ", d:hlt-HSDamage);
		}

        // Actually headshot!
        if (bloodz >= (ownerz + headshotheight))
		{
			ActivatorSound("skull/hit", 127);
			
			// Temporary TID
			int OID = ActivatorTID();
			int UID = UniqueTID();
			
			Thing_ChangeTID(0, UID);
			
			// Play the sound for the player, so they KNOW they scored a headshot
			if (bloodPlayer > 0)
			{
				SetActivator(bloodPlayer);
				LocalAmbientSound("skull/hit", 127);
				Thing_Damage2(UID, HSDamage, "head");
			}
			
			SetActivator(UID);
			Thing_ChangeTID(0, OID);
			
			// Would this kill us?
			// Don't ACTUALLY damage, this sets target
			if (hlt-HSDamage <= 0)
			{
				GiveInventory("IsDecapitated", 1);
				SetActorProperty(0, APROP_HEALTH, 0);
				
				// Failsafe not to play the same anim twice
				if (CheckInventory("DidHeadshot"))
					SetActorState(0, "DecapitatedAnim", true);
				else
					SetActorState(0, "Death.head", true);
			}
		}
        
        // leg shot
        // uncomment and do your own custom leg shot damage states here.
        /*if (bloodz < (ownerz + legshotheight))
        {
            //printbold(s: "legshot!");
            Thing_Damage2(0, 0, "LegShotDamage");
        }*/
    }
}
