//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// Z T 2   P E R K   B O N U S E S
// These are actually responsible for controlling the perk bonuses
//
// Every script is SERVERSIDED
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#define NADE_BASE_COUNT 5

// Does this weapon we're holding currently have a perk bonus?
script "IsPerked" () { SetResultValue( IsPerked() ); }
bool IsPerked()
{
	int WI = WeaponByType( GetWeapon() );
	if (WI == -1)
		return false;
		
	for (int l=0; l<WeaponList[WI].PerkSize; l++)
	{
		if (CheckInventory(WeaponList[WI].Perks[l]))
			return true;
	}
	
	return false;
}

// Get the amount of grenades we can carry
int NadeCap() { return NADE_BASE_COUNT + CheckInventory("PerkLevel"); }

void EnsureNades(str class, bool reset = false)
{
	int AC = GetAmmoCapacity(class);
	int NC = NADE_BASE_COUNT;
	if (!reset)
		NC = NadeCap();
	if (AC != NC)
		SetAmmoCapacity(class, NC);
		
	// Whoa now, we have more grenades than we should
	int myNades = CheckInventory(class);
	if (myNades > NC)
		InvEnsure(class, NC);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

int JugArmor() { return 5 * CheckInventory("PerkLevel"); }

// -- JUGGERNAUT
script "PBonus_Juggernaut" (int reset)
{
	int PI = PerkByClass("Perk_Juggernaut");
	int NI = WeaponByType(ZT2Perks[PI].Grenade);
	
	// As long as we are Juggernaut, do this
	while (CheckInventory("Perk_Juggernaut") && Living() && !reset)
	{
		// +1 grenade for each level
		EnsureNades(WeaponList[NI].ammoClassA);
		
		// +5 armor bonus for each level
		int ARM = CheckInventory("Armor");
		int AL = JugArmor();
		if (ARM < AL)
			InvEnsure("JugArmorBonus", AL - ARM);
		
		delay(2);
	}
	
	// Reset our inventory bonuses
	if (reset)
		EnsureNades(WeaponList[NI].ammoClassA, true);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// -- COMMANDO
script "PBonus_Commando" (int reset)
{
	int PI = PerkByClass("Perk_Commando");
	int NI = WeaponByType(ZT2Perks[PI].Grenade);
	
	// As long as we are Commando, do this
	while (CheckInventory("Perk_Commando") && Living() && !reset)
	{
		// +1 grenade for each level
		EnsureNades(WeaponList[NI].ammoClassA);
		delay(2);
	}
	
	// Reset our inventory bonuses
	if (reset)
		EnsureNades(WeaponList[NI].ammoClassA, true);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// Attempt to consume a grenade
script "ConsumeNade" ()
{
	int WI = WeaponByType(GetWeapon());
	if (WI == -1)
		terminate;
		
	// Demolitionist
	// Level 10+ gets 50% chance
	// 0-9 gets 25% chance
	int chance = 100;
	if (CheckInventory("Perk_Demo"))
	{
		chance = 75;
		if (CheckInventory("PerkLevel") >= 10)
			chance = 50;
	}
	
	// Consume it?
	if (Random(0,100) <= chance)
		TakeInventory(WeaponList[WI].ammoClassA, 1);
}

// -- DEMO
script "PBonus_Demo" (int reset)
{
	int PI = PerkByClass("Perk_Demo");
	int NI = WeaponByType(ZT2Perks[PI].Grenade);
	
	// As long as we are Commando, do this
	while (CheckInventory("Perk_Demo") && Living() && !reset)
	{
		// +1 grenade for each level
		EnsureNades(WeaponList[NI].ammoClassA);
		delay(2);
	}
	
	// Reset our inventory bonuses
	if (reset)
		EnsureNades(WeaponList[NI].ammoClassA, true);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// -- RIFLEMAN
script "PBonus_Rifleman" (int reset)
{
	int PI = PerkByClass("Perk_Rifleman");
	int NI = WeaponByType(ZT2Perks[PI].Grenade);
	
	// As long as we are Commando, do this
	while (CheckInventory("Perk_Rifleman") && Living() && !reset)
	{
		// +1 grenade for each level
		EnsureNades(WeaponList[NI].ammoClassA);
		delay(2);
	}
	
	// Reset our inventory bonuses
	if (reset)
		EnsureNades(WeaponList[NI].ammoClassA, true);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// -- PYRO
script "PBonus_Pyro" (int reset)
{
	int PI = PerkByClass("Perk_Pyro");
	int NI = WeaponByType(ZT2Perks[PI].Grenade);
	
	// As long as we are Commando, do this
	while (CheckInventory("Perk_Pyro") && Living() && !reset)
	{
		// +1 grenade for each level
		EnsureNades(WeaponList[NI].ammoClassA);
		delay(2);
	}
	
	// Reset our inventory bonuses
	if (reset)
		EnsureNades(WeaponList[NI].ammoClassA, true);
}

