//===================================================================
// ZOMBIE TORRENT 2 - PERK SYSTEM
// Coded by Zedek the Plague Doctor
//
// Use if you want, I don't really give a shit
//===================================================================

// Script numbers
#define SC_PERKRESET						547
#define SC_PERKDEBUG						548
#define SC_PERKDATALOAD						550
#define SC_GIVEXP							551
#define SC_PERKMENU							553
#define SC_C4BOMB							556
#define SC_LOWHEALTH						565
#define SC_GETSPREAD						566
#define SC_LEVELUPFX						579

//=================

#define HID_YOUARE							451
#define HID_YOUAREW							450

#define PERK_GLOBALNOTIFY_ID				55

#define DATA_NAME							0
#define DATA_INFO							1
#define DATA_ICON							2
#define DATA_ITEM							3
// Allows for each perk having its own level
#define DATA_LEVEL							4
#define DATA_XP								5
#define DATA_XPGOAL							6
#define DATA_GRENADE						7
#define DATA_REDUCTION						8
#define DATA_NADEAMMO						9

#define PERKMENU_TIME						0.1
#define PERKMENU_FADETIME					0.5

// How much does this weapon cost to BUY?
int FinalPrice(int WI)
{
	return WeaponList[WI].Price;
}

// How much does this weapon cost to SELL?
int FinalSellPrice(int WI)
{
	int BuyPrice = FinalPrice(WI);
	return ShaveInt(BuyPrice * 0.6);
}

#define PERK_COUNT							5 
struct PerkBlockT
{
	str Shorthand;			// Appended onto some other things
	str Name;				// Descriptive display name for this perk
	str Item;				// Perk item to give the player
	str Description;		// Small info about this perk
	str Grenade;			// Grenade weapon we're given
	str Reducer;			// Damage reduction
	str Bonuses[3];			// List of bonuses with this perk 
	str YouAre;				// Shown as flavor when you select the perk
	// Bonuses[0]: Level 0-9
	// Bonuses[1]: Level 10-24
	// Bonuses[2]: Level 25
	
	str BonusScript;		// Script responsible for handling our bonuses
	
	str SpawnItem;			// Which item should we start with?
	
	str IconLarge;			// Perk menu icon
	
	// Backend
	str ItemLevel;				// Level item for this perk
	str ItemXP, ItemXPGoal;		// XP / XPMax
};

int						ZT2PerkCount;
PerkBlockT				ZT2Perks[PERK_COUNT];

// Find a perk by item string
int PerkByClass(str class)
{
	for (int l=0; l<ZT2PerkCount; l++)
	{
		if (ZT2Perks[l].Item == class)
			return l;
	}
	
	return -1;
}

// Find the perk that WE currently have!
int FindPerkIndex(bool returnZero = false)
{
	for (int l=0; l<ZT2PerkCount; l++)
	{
		if (CheckInventory(ZT2Perks[l].Item))
			return l;
	}
	
	if (returnZero)
		return 0;
		
	return -1;
}

#define NADE_PLAIN					"Type-97 Grenade"
#define BONUS_PLAIN_10				"- Extended magazine capacity"
#define BONUS_PLAIN_NONE			"- No additional bonuses."

// Register a brand new perk!
void RegisterPerk(str ID, str Name, str Info, str Ins, str BS = "")
{
	ZT2Perks[ZT2PerkCount].Shorthand = ID;
	ZT2Perks[ZT2PerkCount].Name = Name;
	ZT2Perks[ZT2PerkCount].YouAre = Ins;
	ZT2Perks[ZT2PerkCount].Item = StrParam(s:"Perk_", s:ID);
	ZT2Perks[ZT2PerkCount].Bonuses[0] = "This perk has no special bonuses.";
	ZT2Perks[ZT2PerkCount].Bonuses[1] = BONUS_PLAIN_10;
	ZT2Perks[ZT2PerkCount].Bonuses[2] = BONUS_PLAIN_NONE;
	ZT2Perks[ZT2PerkCount].Description = Info;
	ZT2Perks[ZT2PerkCount].Grenade = NADE_PLAIN;
	ZT2Perks[ZT2PerkCount].IconLarge = "PSELNONE";
	ZT2Perks[ZT2PerkCount].Reducer = "";
	ZT2Perks[ZT2PerkCount].SpawnItem = "";
	ZT2Perks[ZT2PerkCount].BonusScript = BS;
	
	ZT2Perks[ZT2PerkCount].ItemLevel = StrParam(s:"PerkLevel_", s:ID);
	ZT2Perks[ZT2PerkCount].ItemXP = StrParam(s:"PerkXP_", s:ID);
	ZT2Perks[ZT2PerkCount].ItemXPGoal = StrParam(s:"PerkXPGoal_", s:ID);
	
	ZT2PerkCount ++;
}

// Change information about the last perk that was registered
void RegisterPerkNade(str Nade) { ZT2Perks[ZT2PerkCount-1].Grenade = Nade; }
void RegisterPerkReducer(str Red) { ZT2Perks[ZT2PerkCount-1].Reducer = Red; }
void RegisterPerkSpawn(str Itm) { ZT2Perks[ZT2PerkCount-1].SpawnItem = Itm; }
void RegisterPerkIcons(str Selection) { ZT2Perks[ZT2PerkCount-1].IconLarge = Selection; }
void RegisterPerkBonuses(str Bon, str Bon10 = BONUS_PLAIN_10, str Bon25 = BONUS_PLAIN_NONE) 
{ 
	ZT2Perks[ZT2PerkCount-1].Bonuses[0] = Bon; 
	ZT2Perks[ZT2PerkCount-1].Bonuses[1] = Bon10;
	ZT2Perks[ZT2PerkCount-1].Bonuses[2] = Bon25;
}

//========================================================
// SPECIFIC LEVEL UNLOCKS
//========================================================

#define LEVEL_UNLOCKS						2

private str ZT2PerkUnlocks[LEVEL_UNLOCKS][2] = {
	{"Increased mag capacity", "All weapons specific to your perk get an additional\nammo boost on top of the initial addition."},
	{"Max perk level", "Congratulations! Ask for a perk reset or keep playing."},
};

private int ZT2PerkUnlockLevels[LEVEL_UNLOCKS] = {
	10,
	25,
};

//=================

//=====================================================
// MAIN EXPERIENCE CAP
//=====================================================

// Sets initial experience caps and items for all perks
void PreparePerkSystem()
{
	int PN = PlayerNumber();
	
	if (StoredInfo[PN].wasSetup)
		return;
		
	StoredInfo[PN].wasSetup = true;
		
	InvEnsure("PerkXPGoal", 100);
	SetAmmoCapacity("PerkXP",100);
	
	// Set all base goals to 100
	for (int m=0; m<ZT2PerkCount; m++)
		InvEnsure(ZT2Perks[m].ItemXPGoal,100);
	
	// Perk debug script
	ACS_ExecuteAlways(SC_PERKDEBUG,0,0,0,0);
}

// PERK DEBUG
// TODO: ONLY EXECUTE THIS IN SINGLEPLAYER
script SC_PERKDEBUG (void) CLIENTSIDE
{
	bool PerkDebug;
	
	if (WrongClient())
		terminate;
	
	while (true)
	{
		PerkDebug = GetCVar("cl_perkdebug");
		
		// Make sure we're using the CVAR
		if (PerkDebug)
		{
			int PI = FindPerkIndex();
			
			str debugString = "\cDSTORED PERK INFORMATION:\n\n";
			
			for (int l=0; l<ZT2PerkCount; l++)
			{
				str col = StrEval(PI == l, "\cJ", "\cK");
				debugString = StrParam(s:debugString, s:col, d:l, s:".) ", s:ZT2Perks[l].Name);
				debugString = StrParam(s:debugString, s:" - Level ", d:CheckInventory(ZT2Perks[l].ItemLevel), s:" (",
					d:CheckInventory(ZT2Perks[l].ItemXP), s:" / ", d:CheckInventory(ZT2Perks[l].ItemXPGoal), s:" XP)\n");
			}
			
			debugString = StrParam(s:debugString, s:"\n\cDCURRENT PERK INFORMATION:\n\nLevel ", d:CheckInventory("PerkLevel"), s:" (",
				d:CheckInventory("PerkXP"), s:" / ", d:CheckInventory("PerkXPGoal"), s:")\n\n",
				s:"PerkXP Capacity: ", d:GetAmmoCapacity("PerkXP"));
				
			// Get current perk grenade
			int WI = WeaponByType(ZT2Perks[PI].Grenade);
			if (WI >= 0)
			{
				debugString = StrParam(s:debugString, s:"\nGrenade Type: ", s:WeaponList[WI].DisplayName, s:" (", s:WeaponList[WI].ammoClassA, s:")",
					s:"\nGrenade Capacity: ", d:GetAmmoCapacity(WeaponList[WI].ammoClassA),
					s:"\nCurrent Nades: ", d:CheckInventory(WeaponList[WI].ammoClassA));
			}
			
			SetFont("TFNDESC");
			ZTHudMessage(64.0, 300.0, LID_PERKDEBUG, debugString, ALIGN_LEFT, ALIGN_TOP, FOREVER);
		}
		
		else
			BlankMessage(LID_PERKDEBUG);
		
		delay(5);
	}
}

//=====================================================
// SCRIPT FOR LOADING DATA
//=====================================================
/*
script SC_PERKDATALOAD (void) NET
{
	int perkNumber;
	
	for (int j=0; j<PERK_COUNT; j++)
	{
		 if (CheckInventory(ZT2Perks[j][DATA_ITEM]))
			perkNumber = j;
	}
	
	if (!PlayerIsLoggedIn(PlayerNumber()))
	{
		if (GameType () != GAME_SINGLE_PLAYER)
		{
		SetFont("BIGFONT");
        HudMessage(s:"\cGYou must login to load your perk data."; 1, 805, CR_WHITE, 0.5, 0.95, 2.0,0.25);
		}
	}
	
	else
	{
	
	ResetLoadData();
	
	str accountName = GetPlayerAccountName(PlayerNumber());
	str namespacer = StrParam(s:accountName, s:"_perkdata");

	SetFont("TYPEWRIT");
    HudMessage(s:"\cILoading your perk data..."; 1, 390, CR_WHITE, 0.5, 0.85, 2.0,0.25);
	
	//==================================================================
	// START LOADING INFO FROM THE DATABASE
	//==================================================================
	
	int xpTotal = 0;
	int xpGoal = 0;
	int xpLevel = 0;
	
	for (int k=0; k<PERK_COUNT; k++)
	{
		if (k != perkNumber)
		{
			xpTotal = GetDBEntry(namespacer, ZT2Perks[k][DATA_XP]);
			xpGoal = GetDBEntry(namespacer, ZT2Perks[k][DATA_XPGOAL]);
			xpLevel = GetDBEntry(namespacer, ZT2Perks[k][DATA_LEVEL]);
				
			GiveInventory(ZT2Perks[k][DATA_XP], xpTotal);
			Print(s:"Loaded ",s:ZT2Perks[k][DATA_XP],s:": ",d:xpTotal);
			GiveInventory(ZT2Perks[k][DATA_XPGOAL], xpGoal);
			Print(s:"Loaded ",s:ZT2Perks[k][DATA_XPGOAL],s:": ",d:xpGoal);
			GiveInventory(ZT2Perks[k][DATA_LEVEL], xpLevel);
			Print(s:"Loaded ",s:ZT2Perks[k][DATA_LEVEL],s:": ",d:xpLevel);
			
			Print(s:"XP: ",d:xpTotal,s:"\nXP Goal: ",d:xpGoal,s:"\nPerk Level: ",d:xpLevel,s:"\n\n\cDCongrats!");
		}
	}
	
	xpTotal = GetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_XP]);
	xpGoal = GetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_XPGOAL]);
	xpLevel = GetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_LEVEL]);
	
	//==================================================================
	// APPLY THE INFO WE LOADED
	//==================================================================
	
	SetAmmoCapacity("PerkXP",CheckInventory(ZT2Perks[perkNumber][DATA_XPGOAL]));
	
	GiveInventory("PerkXP",xpTotal);
	Print(s:"Loaded current XP:",d:CheckInventory(ZT2Perks[perkNumber][DATA_XP]));
	GiveInventory("PerkXPGoal",xpGoal);
	Print(s:"Loaded current XPGoal:",d:CheckInventory(ZT2Perks[perkNumber][DATA_XPGOAL]));
	GiveInventory("PerkLevel",xpLevel);
	Print(s:"Loaded current level:",d:CheckInventory(ZT2Perks[perkNumber][DATA_LEVEL]));
	
	SetFont("TYPEWRIT");
    HudMessage(s:"\cDPerk data in sync."; 1, 390, CR_WHITE, 0.5, 0.85, 2.0,0.25);
	}
}
*/

//=====================================================
// SCRIPT FOR GIVING THE PLAYER XP
//=====================================================

script "GiveXP" (int XP)
{
	int newperkgoal;
	int hasUnlock;
	int unlockNumber;
	int mainID = ActivatorTID();
	int debug = GetCVar("cl_zombiedebugger");
	
	// How much should we multiply XP by?
	int xpMult = GetCVar("sv_ztxpmult");
	if (xpMult <= 0)
		xpMult = 1;
		
	XP *= xpMult;
	
	// No XP to give!
	if (XP <= 0)
	{
		if (debug)
			Print(s:"Tried to give 0 or less XP.");

		terminate;
	}

	// Add to our perk info
	GiveInventory("PerkXP",XP);
	
	// LEVEL UP!
	if (CheckInventory("PerkXP") >= CheckInventory("PerkXPGoal") && CheckInventory("PerkLevel") < 25)
	{
		LocalAmbientSound("perks/levelup",128);
		GiveInventory("PerkLevel",1);
		
		TakeInventory("PerkXP",999999999);
		
		newperkgoal = ShaveInt(CheckInventory("PerkXPGoal") * 1.5);
		
		// Reset our goal
		TakeInventory("PerkXPGoal",999999999);
		GiveInventory("PerkXPGoal",newperkgoal);
		
		SetAmmoCapacity("PerkXP",newperkgoal);
		
		int PI = FindPerkIndex(true);
		ACS_ExecuteAlways(SC_LEVELUPFX,0,CheckInventory("PerkLevel"),PI,0);
		
		// Let everyone know!
		ACS_NamedExecute("LevelUpNotification", 0, PlayerNumber(), CheckInventory("PerkLevel"), PI);
		
		delay(35*4);
		// CHECK TO SEE IF WE HAVE ACHIEVED A PERK BONUS
		for (int p=0;p<LEVEL_UNLOCKS;p++)
		{
			if (CheckInventory("PerkLevel") == ZT2PerkUnlockLevels[p])
			{
				hasUnlock = 1;
				unlockNumber = p;
			}
		}
		
		if (hasUnlock)
		{
			LocalAmbientSound("perk/selectperk",128);
			FadeTo(1.0,1.0,1.0,0.5,0.05);
			Delay(5);
			FadeTo(0.0,0.0,0.0,0.0,0.2);
			SetFont("TYPEWRIT");
			HudMessage(s:"\cKPERK BONUS: \cD",s:ZT2PerkUnlocks[unlockNumber][0]; HUDMSG_TYPEON, 390, CR_WHITE, 1.5, 0.85, 4.0, 0.02, 1.0);
			delay(35);
			SetFont("BIGFONT");
			HudMessage(s:ZT2PerkUnlocks[unlockNumber][1]; HUDMSG_TYPEON, 389, CR_WHITE, 1.5, 0.89, 2.0, 0.02, 1.0);
		}
	}
}

//=====================================================
// SCRIPT FOR SAVING DATA
//=====================================================

// -- RESET ALL PERKS ---------------------------------
script SC_PERKRESET (void) NET
{
	for (int j=0; j<ZT2PerkCount; j++)
	{
		InvEnsure(ZT2Perks[j].ItemXP, 0);
		InvEnsure(ZT2Perks[j].ItemXPGoal, 0);
		InvEnsure(ZT2Perks[j].ItemLevel, 0);
	}
	
	InvEnsure("PerkXP", 0);
	InvEnsure("PerkXPGoal", 0);
	InvEnsure("PerkXPLevel", 0);
	
	delay(1);
	
	InvEnsure("PerkXPGoal", 100);

	// Set all base perk goals to 100
	for (int m=0; m<ZT2PerkCount; m++)
		InvEnsure(ZT2Perks[m].ItemXPGoal, 100);
	
	SetAmmoCapacity("PerkXP",100);
	
	ACS_ExecuteAlways(552,0,0,0,0);
	
	SetFont("BIGFONT");
    HudMessage(s:"\cGYour perks have been reset."; 1, 869, CR_WHITE, 0.5, 0.3, 2.0,0.25);
}

/*
script 552 (void) NET
{
	int perkNumber;
	
	perkNumber = -1;
	
	// Loop through all of the perks and find out which one we're using
	for (int j=0; j<PERK_COUNT; j++)
	{
		 if (CheckInventory(ZT2Perks[j][DATA_ITEM]))
			perkNumber = j;
	}
	
	// Not logged in
	if (!PlayerIsLoggedIn(PlayerNumber()))
	{
		if (GameType () != GAME_SINGLE_PLAYER)
		{
		SetFont("BIGFONT");
        HudMessage(s:"\cGYou must login to save your perk data."; 1, 805, CR_WHITE, 0.5, 0.95, 2.0,0.25);
		}
	}
	
	// If we're logged in
	else if (PerkNumber != -1)
	{
		str accountName = GetPlayerAccountName(PlayerNumber());
		str namespacer = strparam(s:accountName, s:"_perkdata");

		SetFont("TYPEWRIT");
		HudMessage(s:"\cISaving your perk data..."; 1, 390, CR_WHITE, 0.5, 0.85, 2.0,0.25);
		
		//==================================================================
		// START PUTTING INFO INTO THE DATABASE
		//==================================================================
		
		int xpTotal = 0;
		int xpGoal = 0;
		int xpLevel = 0;
		
		// -- START WRITING --
		BeginDBTransaction();
		
		for (int k=0; k<PERK_COUNT; k++)
		{
			// Save every perk except for the one that we're using
			if (k != perkNumber)
			{
				xpTotal = CheckInventory(ZT2Perks[k][DATA_XP]);
				xpGoal = CheckInventory(ZT2Perks[k][DATA_XPGOAL]);
				xpLevel = CheckInventory(ZT2Perks[k][DATA_LEVEL]);
				
				SetDBEntry(namespacer, ZT2Perks[k][DATA_XP], xpTotal);
				Print(s:"Saved ",s:ZT2Perks[k][DATA_XP],s:": ",d:xpTotal);
				SetDBEntry(namespacer, ZT2Perks[k][DATA_XPGOAL], xpGoal);
				Print(s:"Saved ",s:ZT2Perks[k][DATA_XPGOAL],s:": ",d:xpGoal);
				SetDBEntry(namespacer, ZT2Perks[k][DATA_LEVEL], xpLevel);
				Print(s:"Saved ",s:ZT2Perks[k][DATA_LEVEL],s:": ",d:xpLevel);

				Print(s:"XP: ",d:xpTotal,s:"\nXP Goal: ",d:xpGoal,s:"\nPerk Level: ",d:xpLevel,s:"\n\n\cDCongrats!");
			}
		
		}
		
		// Save the perk that we're using
		SetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_XP], CheckInventory("PerkXP"));
			Print(s:"Saved ",s:ZT2Perks[perkNumber][DATA_XP],s:": ",d:CheckInventory("PerkXP"));
		SetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_XPGOAL], CheckInventory("PerkXPGoal"));
			Print(s:"Saved ",s:ZT2Perks[perkNumber][DATA_XPGOAL],s:": ",d:CheckInventory("PerkXPGoal"));
		SetDBEntry(namespacer, ZT2Perks[perkNumber][DATA_LEVEL], CheckInventory("PerkLevel"));
			Print(s:"Saved ",s:ZT2Perks[perkNumber][DATA_LEVEL],s:": ",d:CheckInventory("PerkLevel"));

		// -- END WRITING --
		EndDBTransaction();
		
		//==================================================================
		// APPLY THE INFO WE LOADED
		//==================================================================
		
		SetFont("TYPEWRIT");
		HudMessage(s:"\cDData saved."; 1, 390, CR_WHITE, 0.5, 0.85, 2.0,0.25);
	}
	else
	{
		SetFont("TYPEWRIT");
		HudMessage(s:"\cDYou're using a strange perk!"; 1, 390, CR_WHITE, 0.5, 0.85, 2.0,0.25);
	}
}
*/

//========================================================
// PERK BONUSES
// Always running
//
// Also controls showing the perk of other players
//========================================================

#define PERKINFO_ID				200

// player view height
#define PLAYER_VIEWHEIGHT 41

function bool CheckPlayerCrouching(void)
{
	bool val = false;
	
    if(GetActorViewHeight(ActivatorTID()) < PLAYER_VIEWHEIGHT << 16)
        val = true;
    else
        val = false;
    
    return val;
}

// Called constantly on the SERVER from HealthRegen script
// Shows mouse-over information if you're looking at someone
//
// This is UNSCALED and depends on YOU having the proper
// resolution items on the server's end

struct LookedAtT
{
	int ID;
	str Perk, Name;
	int Level;
};

LookedAtT LookedAt[MAXPLAYERS];

void HandleMouseOver()
{
	int actID, actNum;
	bool showMessage;

	actID = ActivatorTID();
	actNum = PlayerNumber();
	
	int them = -1;
	
	// Set to the player we're looking at!
	if (SetActivatorToTarget(0))
	{
		int PN = PlayerNumber();
		
		// This is a valid player, and it's not ourselves
		if (PN >= 0 && PN != actNum)
		{
			them = PN;
			
			// We started looking at this player, or a new player
			if (PN != LookedAt[actNum].ID || CheckInventory("PerkLevel") != LookedAt[actNum].Level)
			{
				showMessage = true;
				
				LookedAt[actNum].ID = PN;
				LookedAt[actNum].Name = StrParam(n:0);
				
				int PI = FindPerkIndex();
				if (PI >= 0)
				{
					LookedAt[actNum].Perk = ZT2Perks[PI].Name;
					LookedAt[actNum].Level = CheckInventory("PerkLevel");
				}
				else
					LookedAt[actNum].Level = -1;
			}
		}
	}
	SetActivator(actID);
	
	// We should show a message!
	if (showMessage)
	{
		int CenX = Half(ScreenWidth() * 1.0);
		
		SetFont("TFNTAB");
		ZTHudMessage(CenX, -82.0, PERKINFO_ID, LookedAt[actNum].Name, ALIGN_CENTER, ALIGN_BOTTOM, FOREVER);
		SetFont("TFNDESC");
		
		str PerkString = StrParam(s:"Level ",d:LookedAt[actNum].Level, s:" ", s:LookedAt[actNum].Perk);
		
		ZTHudMessage(CenX, -80.0, PERKINFO_ID+1, StrEval(LookedAt[actNum].Level >= 0, "", PerkString), ALIGN_CENTER, ALIGN_TOP, FOREVER);
	}
	
	// Stop showing a message
	else if (them == -1 && LookedAt[actNum].ID >= 0)
	{
		LookedAt[actNum].ID = -1;
		BlankMessage(PERKINFO_ID);
		BlankMessage(PERKINFO_ID+1);
	}
}

// We selected a perk from the menu, or attempted to
function void SelectPerk(int pos)
{
	int perkNumber = FindPerkIndex();

	InvEnsure("UsedPerkMenuOnce", 1);

	FreezeMe(false);
	TakeInventory("MenuWeapon", 1);

	if (pos != perkNumber)
	{
		SwapPerk(pos);
		// Let SURVIVAL MODE know we selected a perk!
		StoredInfo[PlayerNumber()].pickedPerk = true;
	}
}

function void ResetLoadData(void)
{
	InvEnsure("PerkLevel", 0);
	InvEnsure("PerkXP", 0);
	InvEnsure("PerkXPGoal", 0);
}

// Prepare all necessary items for selecting a perk
// Takes unnecessary grenades, etc. and sets backend XP
function void SwapPerk(int Z)
{
	// This is the perk we were previously
	// -1 if we didn't even have one to begin with
	int PI = FindPerkIndex();
	bool NullPerk = (PI == -1);

	// Take ALL perk items and grenades
	for (int j=0; j<PERK_COUNT; j++)
	{
		if (ZT2Perks[j].Reducer != "")
			InvEnsure(ZT2Perks[j].Reducer, 0);
			
		InvEnsure(ZT2Perks[j].Grenade, 0);
		InvEnsure(ZT2Perks[j].Item, 0);
		
		// This perk is the one we were PREVIOUSLY
		// We need to store our XP info in the backend
		if (j == PI)
		{
			InvEnsure(ZT2Perks[j].ItemXP, CheckInventory("PerkXP"));
			InvEnsure(ZT2Perks[j].ItemXPGoal, CheckInventory("PerkXPGoal"));
			InvEnsure(ZT2Perks[j].ItemLevel, CheckInventory("PerkLevel"));
		}
	}
	
	// End our PREVIOUS perk script
	if (PI >= 0 && ZT2Perks[PI].BonusScript != "")
		ACS_NamedExecuteAlways(ZT2Perks[PI].BonusScript, 0, 1);
		
	// Now that our XP is stored in the backend, let's update it to our current perk
	InvEnsure("PerkXP", CheckInventory(ZT2Perks[Z].ItemXP));
	SetAmmoCapacity("PerkXP",CheckInventory(ZT2Perks[Z].ItemXPGoal));
	
	InvEnsure("PerkXPGoal", CheckInventory(ZT2Perks[Z].ItemXPGoal));
	InvEnsure("PerkLevel", CheckInventory(ZT2Perks[Z].ItemLevel));
	
	// Spawn item!
	if (NullPerk && ZT2Perks[Z].SpawnItem != "")
		InvEnsure(ZT2Perks[Z].SpawnItem, 1);
	
	if (ZT2Perks[Z].Reducer != "")
		InvEnsure(ZT2Perks[Z].Reducer,1);
		
	InvEnsure(ZT2Perks[Z].Grenade, 1);
	InvEnsure(ZT2Perks[Z].Item, 1);
	
	// Start our CURRENT perk script
	if (ZT2Perks[Z].BonusScript != "")
		ACS_NamedExecuteAlways(ZT2Perks[Z].BonusScript, 0);
}

//==============================================================
// CALLED BY C4
//==============================================================

script SC_C4BOMB (int mode)
{
	int bombTID = 0;
	
	// If we're throwing a C4
	if (mode==0)
	{
		Thing_ChangeTID(0, 1337);
		delay(1);
		SetActivatorToTarget(0);
		bombTID = ActivatorTID() + 100;
		delay(1);
		Thing_ChangeTID(1337,bombTID);
	}
	
	// If we're blowing up C4
	if (mode==1)
	{
		bombTID = ActivatorTID() + 100;
		SetActorState(bombTID,"Detonate");
	}
}

//==============================================================
// CALLED BY TNT
//==============================================================

script 557 (int mode)
{
	int TNTtimer = 0;
	
	// Figure out how much time we have left
	
	if (mode==0)
	{
	Thing_ChangeTID(0, 1338);
	delay(1);
	SetActivatorToTarget(0);
	TNTtimer = CheckInventory("FuseTimer") - 12;
	delay(1);
	GiveActorInventory(1338,"TNTTimer",TNTtimer);
	//PrintBold(s:"TNT timer given: ",d:TNTtimer);
	Thing_ChangeTID(1338,0);
	}
	
	// Count down a timer
	
	if (mode==1)
	{
	GiveInventory("TNTTimer",1);
	if (CheckInventory("TNTTimer") >= 15)
		SetActorState(0,"Boom");
	}
}

//==============================================================
// GETGRENADEAMMO
// Returns the amount of grenade ammo that you have
//==============================================================

script "GetGrenadeAmmo" (void) { SetResultValue( GetGrenadeAmmo() ); }
int GetGrenadeAmmo()
{
	int PI = FindPerkIndex();
	if (PI == -1)
		return 0;
		
	// Find the grenade index in the weapon list
	int WI = WeaponByType(ZT2Perks[PI].Grenade);
	if (WI == -1)
		return 0;
		
	return CheckInventory(WeaponList[WI].ammoCapA);
}

//=========================================================================
// MELEE MOVEMENT SCRIPT
// Used for melee weapons
// Controls attack based on which key you're pressing like KF2
//=========================================================================
script 559 (void)
{
	int buttons = GetPlayerInput(-1, INPUT_BUTTONS);
	
	// MOVE LEFT
	if (buttons == BT_MOVELEFT || (buttons & BT_MOVELEFT && buttons & BT_ATTACK))
		SetResultValue(0);
	// MOVE RIGHT
	else if (buttons == BT_MOVERIGHT || (buttons & BT_MOVERIGHT && buttons & BT_ATTACK))
		SetResultValue(1);
	// MOVE UP OR DOWN
	else if ((buttons == BT_FORWARD || buttons == BT_BACK) || ((buttons & BT_FORWARD || buttons & BT_BACK) && buttons & BT_ATTACK))
		SetResultValue(2);
	else
		SetResultValue(3);
}

// Called by keyconf, OPEN THE PERK MENU!
script 564 (void) NET
{
	ACS_ExecuteAlways(SC_PERKMENU,0,0,0,0);		// Force perk select
}

// LOW HEALTH SCRIPT
script SC_LOWHEALTH (void)
{	
	if (GetActorProperty(0,APROP_Health) > 0)
	{
		// If our health is 10 or below
		if (GetActorProperty(0,APROP_Health) > 0 && GetActorProperty(0,APROP_Health) <= 10)
		{
		GiveInventory("PowerRedScreen",1);
		LocalAmbientSound("player/heartbeat",127);
		FadeTo(255,0,0,0.25,0.14);
		delay(5);
		FadeTo(0,0,0,0.0,0.14);
		delay(5);
		}
		// Health is between 10 and 25
		else if (GetActorProperty(0,APROP_Health) > 10 && GetActorProperty(0,APROP_Health) <= 25)
		{
		TakeInventory("PowerRedScreen",1);
		LocalAmbientSound("player/heartbeat",127);
		FadeTo(255,0,0,0.15,0.3);
		delay(11);
		FadeTo(0,0,0,0.0,0.3);
		delay(11);
		}
		else
		{
		TakeInventory("PowerRedScreen",1);
		}
	}
	else
	{
		TakeInventory("PowerRedScreen",1);
	}
	
	delay(1);
	restart;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// For level-up FX
str markPics[9] = {
	"LVLBLOD9",
	"LVLBLOD8",
	"LVLBLOD7",
	"LVLBLOD6",
	"LVLBLOD5",
	"LVLBLOD4",
	"LVLBLOD3",
	"LVLBLOD2",
	"LVLBLOD1",
};

// Fancy level-up shit
script SC_LEVELUPFX (int perkLvl, int pNumber) CLIENTSIDE
{
	// 0: Bullets
	// 1: Blood
	int fancyState;
	int bulletCount;
	int markCounter;
	
	int SW;
	int SH;
	int bulletLength;
	str perkDisplay = ZT2Perks[pNumber].Name;
		
	SW = FixedDiv(GetCVar("vid_defwidth")*1.0,2.0);
	SH = GetCVar("vid_defheight")*1.0;
	
	// Total length of the bullets
	bulletLength = FixedDiv(FixedMul((14.0+2.0),15.0),2.0);
	
	// Bullets
	while (fancyState == 0)
	{
		SetFont("LVLBULLT");
		HudMessageUnscaledSlot((SW-bulletLength) + FixedMul(14.0+2.0,bulletCount*1.0), -200.0, "a", 0, 1, 950+bulletCount, 15.0);
		SetFont("SMALLFONT");
		
		bulletCount ++;
		
		if (bulletCount >= 15)
			fancyState ++;
			
		delay(1);
	}
	
	delay(5);
	
	// LocalAmbientSound("slot/win",128);
	
	// Flash level up
	SetFont("TYPEWRIT");
	HudMessageUnscaledSlot(SW, -200.0-16.0, "\cJL E V E L   U P", 1, 1, 946, 0.05);
	HudMessageUnscaledSlot(SW, -200.0-16.0, "\cDL E V E L   U P", 1, 1, 947, 4.0);
	
	SetFont("BIGFONT");
	HudMessageUnscaledSlot(SW, -200.0+10.0, StrParam(s:"\cJLevel ",d:perkLvl,s:" ",s:perkDisplay), 1, 1, 944, 0.05);
	HudMessageUnscaledSlot(SW, -200.0+10.0, StrParam(s:"\cKLevel ",d:perkLvl,s:" ",s:perkDisplay), 1, 1, 945, 4.0);
	
	SetFont("LEVELBOX");
	HudMessageUnscaledSlot(SW, -200.0, "a", 1, 1, 948, 15.0);
	
	SetFont("SMALLFONT");
	
	// Mark
	while (fancyState == 1)
	{
		SetFont(markPics[markCounter]);
		HudMessageUnscaledSlot(SW, -200.0, "a", 1, 1, 949, 2.0);
		SetFont("SMALLFONT");
		markCounter ++;
		
		if (markCounter >= 9)
			fancyState = 2;
			
		delay(1);
	}
	
	// Re-draw bullets
	for (int l=0; l<15; l++)
	{
		SetFont("LVLBULLT");
		HudMessageUnscaledSlot((SW-bulletLength) + FixedMul(14.0+2.0,l*1.0), -200.0, "a", 0, 1, 950+l, 2.0);
		SetFont("SMALLFONT");
	}
	
	SetFont("TYPEWRIT");
	HudMessageUnscaledSlot(SW, -200.0-16.0, "\cDL E V E L   U P", 1, 1, 947, 2.0);
	SetFont("BIGFONT");
	HudMessageUnscaledSlot(SW, -200.0+10.0, StrParam(s:"\cKLevel ",d:perkLvl,s:" ",s:perkDisplay), 1, 1, 945, 2.0);
	SetFont("LEVELBOX");
	HudMessageUnscaledSlot(SW, -200.0, "a", 1, 1, 948, 2.0);
	SetFont("SMALLFONT");
}

//---SPREAD ADJUST SCRIPT----------------------------------
//-- ADJUSTS SPREAD DEPENDING ON SEVERAL OTHER VARIABLES --

script "GetSpread" (int fallback, int isY)
{
	SetResultValue(finalSpread(fallback, isY));
}

function int finalSpread(int fallback, bool vertical)
{
	int WI = CheckInventory("StoredIndex")-1;
	int spreadX = fallback * 1.0;
	int spreadY = fallback * 1.0;
	int crouchMult = SPREAD_CROUCH;
	int semiMult = SPREAD_SEMI;
	int adsMult = SPREAD_ADS;
	bool isSemi = false;
	
	if (WI != -1)
	{
		if (WeaponList[WI].spreadX >= 0.0)
			spreadX = WeaponList[WI].spreadX;
			
		if (WeaponList[WI].spreadY >= 0.0)
			spreadY = WeaponList[WI].spreadY;
			
		adsMult = WeaponList[WI].spreadMultIS;
		crouchMult = WeaponList[WI].spreadMultCrouch;
		
		if (WeaponList[WI].fireModeItem != "" && CheckInventory(WeaponList[WI].fireModeItem))
			isSemi = true;
	}
	
	int finalSpread = spreadX;
	
	// Y spread
	if (vertical)
		finalSpread = spreadY;
		
	// Are we crouching?
	if (CheckInventory("IsCrouched"))
		finalSpread = FixedMul(finalSpread, crouchMult);
		
	// Semi-automatic
	if (isSemi)
		finalSpread = FixedMul(finalSpread, semiMult);
		
	// Using iron-sights
	if (CheckInventory("InIronSights"))
		finalSpread = FixedMul(finalSpread, adsMult);
	
	// Singleplayer debug
	if (SinglePlayer() && GetCVar("cl_zombiedebugger"))
	{
		str spreadDebug = StrParam(s:"Final ", s:StrEval(vertical, "X Spread: ", "Y Spread: "), f:finalSpread, s:" -> ", d:ShaveInt(finalSpread));
		spreadDebug = StrParam(s:spreadDebug, s:"\nCrouch Mult: ", f:crouchMult, s:"\nSemi Mult: ", f:semiMult, s:"\nSemi-Automatic: ", d:isSemi);
		spreadDebug = StrParam(s:spreadDebug, s:"\nADS Mult: ", f:adsMult);
		SetFont("TFNDESC");
		PrintBold(s:spreadDebug);
	}
	
	// Rounding would probably be more accurate, but we'll be
	// generous and floor it to give an extra reduction
	
	return ShaveInt(finalSpread);
}

// Someone else leveled up!
// SERVER -> CLIENT
script "LevelUpNotification" (int PN, int LVL, int PI) CLIENTSIDE
{
	// This is US, we want to know if someone ELSE leveled up
	if (ConsolePlayerNumber() == PN)
		terminate;
		
	SetFont("TFNDESC");
	str msg = StrParam(n:PN,s:" \cJis now a \cDLevel ",d:LVL,s:" ",s:ZT2Perks[PI].Name,s:"\cJ!");
	
	int CenX = Half(ScreenWidth() * 1.0);
	ZTHudMessage(CenX, -80.0, PERK_GLOBALNOTIFY_ID, msg, ALIGN_CENTER, ALIGN_CENTER, 2.0);
}

//==================================================================
// AMMO HUD DISPLAY
// Used because SBARINFO is a fucking cunt and doesn't
// like to accept items with spaces in it
//==================================================================

function int ControlAmmoJunk(int unused)
{
	//================================================================
	// M79: INCENDIARY AMMO
	//================================================================
	if (CheckInventory("M79 Grenade Launcher Incendiary"))
	{
		if (!CheckInventory("M79IncendiaryHUD"))
			GiveInventory("M79IncendiaryHUD",1);
	}
	else
		TakeInventory("M79IncendiaryHUD",1);
		
	//================================================================
	// M79: SHOTGUN AMMO
	//================================================================
	if (CheckInventory("M79 Grenade Launcher Shotgun"))
	{
		if (!CheckInventory("M79ShotgunHUD"))
			GiveInventory("M79ShotgunHUD",1);
	}
	else
		TakeInventory("M79ShotgunHUD",1);
	
	//================================================================
	// ORDER PISTOL: EXPLOSIVE ROUNDS
	//================================================================
	if (CheckInventory("Order Pistol Explosive"))
	{
		if (!CheckInventory("OrderExplosiveHUD"))
			GiveInventory("OrderExplosiveHUD",1);
	}
	else
		TakeInventory("OrderExplosiveHUD",1);
		
	return true;
}

// Perked headshot mult
int PerkedHeadshotMult(void)
{
	if (CheckInventory("Perk_Rifleman"))
	{
		if (CheckInventory("PerkLevel") >= 10)
			return 2.0;
			
		return 1.5;
	}
	
	return 1.0;
}

//=====================================================
//
// A M M O   B O N U S E S
//
//=====================================================

void ZT2PerkSystem_AmmoSetup()
{
	// RIFLEMAN
	MagBonus("Perk_Rifleman", "OrderPrimary", 15, 20);
	MagBonus("Perk_Rifleman", "M1Primary", 10, 12);
	MagBonus("Perk_Rifleman", "ZedPrimary", 10, 14);
	
	// SUPPORT
	MagBonus("Perk_Juggernaut", "AA12Primary", 25, 30);
	MagBonus("Perk_Juggernaut", "DukePrimary", 10, 12);
	MagBonus("Perk_Juggernaut", "SpasPrimary", 10, 12);
	
	// PYRO
	MagBonus("Perk_Pyro", "CirculoPrimary", 140, 180);
	MagBonus("Perk_Pyro", "MAC10Primary", 40, 50);
	
	// COMMANDO
	MagBonus("Perk_Commando", "StenPrimary", 40, 48);
	MagBonus("Perk_Commando", "PPSHPrimary", 85, 100);
	MagBonus("Perk_Commando", "M16Primary", 45, 60);
	MagBonus("Perk_Commando", "MP5Primary", 48, 64);
	MagBonus("Perk_Commando", "MP7Primary", 30, 40);
	MagBonus("Perk_Commando", "MP40Primary", 40, 48);
	MagBonus("Perk_Commando", "RavagerPrimary", 125, 150);
	
	// DEMO
	MagBonus("Perk_Demo", "Pulverizer", 7, 9);
}

//=====================================================
//
// A C T U A L   S T O C K   P E R K S
//
//=====================================================

// This should be called on the server AND client
void ZT2PerkSystem_Init(int BeClient)
{
	// Prevents double-register in singleplayer
	if (!IsClient() && BeClient)
		return;
		
	// -- JUGGERNAUT
	RegisterPerk("Juggernaut", "Juggernaut", "Specializes in shotguns. Up close and personal!", "Get up close and pump some pellets!", "PBonus_Juggernaut");
	RegisterPerkReducer("PowerReduction_Juggernaut");
	RegisterPerkIcons("PSELJUGG");
	RegisterPerkSpawn("Pump Shotgun");
	RegisterPerkBonuses("- Ammo bonus on all shotgun weapons\n\
- +1 extra grenade per level\n\
- +5 armor bonus per level\n\
- 25% resistance to all normal damage\n\
- $100 discount on shotgun weapons every level");

	// -- COMMANDO
	RegisterPerk("Commando", "Commando", "Fully automagical, pump some lead with rapid fire!", "Use fire modes situationally.", "PBonus_Commando");
	RegisterPerkIcons("PSELCOMM");
	RegisterPerkSpawn("Sten MK II");
	RegisterPerkBonuses("- Ammo bonus on all fast-firing bullet weapons\n\
- +1 extra grenade per level\n\
- $100 discount on assault weapons every level");
	
	// -- DEMO
	RegisterPerk("Demo", "Demolitionist", "This perk \"explodes\" with style and flair, satisfying!", "Group enemies into large clusters!", "PBonus_Demo");
	RegisterPerkIcons("PSELDEMO");
	RegisterPerkSpawn("Sticky Bomb");
	RegisterPerkReducer("PowerReduction_Demo");
	RegisterPerkBonuses("- Ammo bonus on all explosive weapons\n\
- +1 extra grenade per level\n\
- 25% chance of not using Type-97 ammo\n\
- 80% resistance to explosive damage\n\
- $100 discount on explosive weapons every level", StrParam(s:BONUS_PLAIN_10, s:"\n- 50% chance of not using Type-97 ammo"));
	
	// -- RIFLEMAN
	RegisterPerk("Rifleman", "Rifleman", "Pop some skulls from a distance with precision!", "Score headshots for critical damage!", "PBonus_Rifleman");
	RegisterPerkIcons("PSELSHRP");
	RegisterPerkSpawn("M1Garand");
	RegisterPerkBonuses("- Ammo bonus on all rifle / sniper weapons\n\
- +1 extra grenade per level\n\
- $100 discount on rifle/sniper weapons every level", StrParam(s:BONUS_PLAIN_10, s:"\n- Additional 50% headshot damage"));
	
	// -- PYRO
	RegisterPerk("Pyro", "Pyromaniac", "The king of crowd control, fit for flaming fun!", "Set zombies alight, burn them down!", "PBonus_Pyro");
	RegisterPerkIcons("PSELFIRE");
	RegisterPerkSpawn("MAC-10");
	RegisterPerkReducer("PowerReduction_Pyro");
	RegisterPerkBonuses("- Ammo bonus on all incendiary weapons\n\
- +1 extra grenade per level\n\
- 80% resistance to fire damage\n\
- $100 discount on incendiary weapons every level");
}