//===========================================================
// ISOLATED PLAYLIST ACS
// Can be modded to change the tracks ZT2 plays
//===========================================================

//=====================================================
// ACTUAL MUSIC DATA - DO NOT CHANGE THIS
//=====================================================

#define MAX_TRACKS 99

struct MusicEntry
{
	str Artist, Song, File;
};

struct MusicListHolder
{
	struct MusicEntry CombatTracks[MAX_TRACKS];
	struct MusicEntry CalmTracks[MAX_TRACKS];
	
	struct MusicEntry CCombatTracks[MAX_TRACKS];
	struct MusicEntry CCalmTracks[MAX_TRACKS];
	
	int availableTracks, availableTraderTracks;
	int availableCTracks, availableCTraderTracks;
	bool CustomCombat, CustomCalm;
};

struct MusicListHolder MusicList;

//=====================================================================
// v v v DO NOT CHANGE THESE FUNCTIONS v v v
//=====================================================================

// -- MAP FUNCTIONS --
// -- FOR MUSIC!
void AddMapBattle(str track, str song, str artist)
{
	MusicList.CustomCombat = true;
	int AT = MusicList.availableCTracks;
	MusicList.CCombatTracks[AT].File = track;
	MusicList.CCombatTracks[AT].Song = song;
	MusicList.CCombatTracks[AT].Artist = artist;
	MusicList.availableCTracks ++;
}

void AddMapTrader(str track, str song, str artist)
{
	MusicList.CustomCalm = true;
	int AT = MusicList.availableCTraderTracks;
	MusicList.CCalmTracks[AT].File = track;
	MusicList.CCalmTracks[AT].Song = song;
	MusicList.CCalmTracks[AT].Artist = artist;
	MusicList.availableCTraderTracks ++;
}

void AddMusicTrack(str track, str song, str artist)
{
	int AT = MusicList.availableTracks;
	MusicList.CombatTracks[AT].File = track;
	MusicList.CombatTracks[AT].Song = song;
	MusicList.CombatTracks[AT].Artist = artist;
	MusicList.availableTracks ++;

	// DEBUG: Use later
	if (GetCVar("sv_playlistdebug"))
		Print(s:"(",d:AT,s:") Added song ",s:track,s:": ",s:artist,s:" - ",s:song);
}

void AddTraderTrack(str track, str song, str artist)
{
	int AT = MusicList.availableTraderTracks;
	MusicList.CalmTracks[AT].File = track;
	MusicList.CalmTracks[AT].Song = song;
	MusicList.CalmTracks[AT].Artist = artist;
	MusicList.availableTraderTracks ++;

	// DEBUG: Use later
	if (GetCVar("sv_playlistdebug"))
		Print(s:"(",d:AT,s:") Added trader song ",s:track,s:": ",s:artist,s:" - ",s:song);
}

void ClearMusicTracks(void)
{
	MusicList.availableTracks = 0;
}

void ClearTraderTracks(void)
{
	MusicList.availableTraderTracks = 0;
}

// Debug script of some sort
script "PlaylistDebug" (void) NET
{
	Print(s:"availableTracks is ",d:MusicList.availableTracks);
	Print(s:MusicList.CombatTracks[0].Artist);
	Print(s:"END OF ARTIST");
	Print(s:MusicList.CombatTracks[0].Song);
	Print(s:"END OF SONG");
	Print(s:MusicList.CombatTracks[0].File);
}

// Play actual trader music!
void PlayTraderTrack()
{
	int cap, ran;
	int cust = MusicList.CustomCalm;
	
	if (!cust)
		cap = MusicList.availableTraderTracks;
	else
		cap = MusicList.availableCTraderTracks;
	
	if (cap > 1)
		ran = random(0, cap-1);
	else
		ran = 0;
	
	// SET TRADER MUSIC
	if (!cust)
		SetMusic(MusicList.CalmTracks[ran].File,0);
	else
		SetMusic(MusicList.CCalmTracks[ran].File,0);
	
	DisplayTrackInfo(ran, 1);
}

// Play actual combat music!
void PlayCombatTrack()
{
	int cap, ran;
	int cust = MusicList.CustomCombat;
	
	if (!cust)
		cap = MusicList.availableTracks;
	else
		cap = MusicList.availableCTracks;
	
	if (cap > 1)
		ran = random(0, cap-1);
	else
		ran = 0;
	
	// SET COMBAT MUSIC
	if (!cust)
		SetMusic(MusicList.CombatTracks[ran].File,0);
	else
		SetMusic(MusicList.CCombatTracks[ran].File,0);
	
	DisplayTrackInfo(ran, 0);
}

//=====================================================================
// ^ ^ ^ DO NOT CHANGE THESE FUNCTIONS ^ ^ ^
//=====================================================================

void InitZT2Tracks()
{
	// Just in case
	ClearMusicTracks();
	ClearTraderTracks();
	
	// Battle music
	AddMusicTrack("FIGHT1","Seizure of Power","Marilyn Manson");
	AddMusicTrack("FIGHT2","Sounds of Decay","Sonic Mayhem");
	AddMusicTrack("FIGHT3","Adrenaline","Sonic Mayhem");
	AddMusicTrack("Q2RAGE","Rage","Sonic Mayhem");
	AddMusicTrack("KILLEVRY","Kill Everyone","Mick Gordon");
	AddMusicTrack("DOOME1M1","Slaughter Machine","Neurological");
	AddMusicTrack("QUAKGRAV","Gravity Well","Sonic Mayhem");
	AddMusicTrack("CARMINDU","Industrial","Lee Groves");
	AddMusicTrack("CARMFEAR","Demanufacture","Fear Factory");
	
	// Trader music
	AddTraderTrack("TRADER1","Susan's Blue Sheep","Richard Henley");
	AddTraderTrack("TRADER2","Squirrel Deck","Meteorite Jesus");
	AddTraderTrack("TRADER3","Cthulhu","David Pittman");
	AddTraderTrack("TRADER4","Mental Anguish", "Sonic Mayhem");
	AddTraderTrack("UNDONECD","Undone","Kevin Sherwood");
	AddTraderTrack("REDAMNED","Re-Damned","James McCawley");
	AddTraderTrack("KILLWADE","Wading Through The Bodies","zYnthetic");
	AddTraderTrack("DOOMDEMO","Credits/Demo (Doom PSX)","Aubrey Hodges");
	AddTraderTrack("BOP2MAIN","BO2: Main","Trent Reznor");
	AddTraderTrack("CARDCAST","Card Castles In The Sky","Jason Tai");
	
	//-- NEW TO 2.6 --
	AddMusicTrack("THEGRIND","The Grinder","Rolf Anton Krueger");
	AddMusicTrack("TIERLINE","Tier","Front Line Assembly");
	AddMusicTrack("BODYHAMR","Body Hammer","Fear Factory");
	AddTraderTrack("AFTRMATH","Aftermath","Trent Reznor");
	AddTraderTrack("ROCKJUMP","Rocket Jump","Sonic Mayhem");
	AddTraderTrack("VOICESIN","Voices In Your Head","James McCawley");
}