str lastWeapon[MAXPLAYERS];

script "LastWeaponHandler" (void)
{
    int pn            = PlayerNumber();
    str currentWeapon = GetWeapon();
	str temp;
	int switchFix = 0;
    lastWeapon[pn]    = currentWeapon;
    
    while (true)
    {
		str GW = GetWeapon();
		
		// It is not a syringe!
		if (StrICmp(GW, "Syringe")==0 || StrICmp(GW,"Type-97 Grenade")==0 || StrICmp(GW, "MenuWeapon")==0)
		{
			if (!switchFix)
			{
				switchFix=1;
				temp= currentWeapon;
				currentWeapon=lastWeapon[pn];
				lastWeapon[pn]= temp;
			}
		}
		else
		{
			// We switched weapons
			if (StrICmp(currentWeapon, GW))
			{
				lastWeapon[pn] = currentWeapon;
				WeaponSwitched(GW);
				ApplyFiringMode(GW);
			}
			switchFix = 0;
		//	if (StrICmp(GetWeapon(), "Syringe"))
			currentWeapon = GW;
		}
		
		
        Delay(1);
    }
}

// We selected a new weapon
void WeaponSwitched(str wep)
{
	int WI = WeaponByType(wep);

	if (WI == -1)
	{
		// We can't use -1, so let's use 0
		InvEnsure("StoredIndex", 0);
		InvEnsure("UseACSAmmoDisplay", 0);
		return;
	}
	
	InvEnsure("StoredIndex", WI+1);
	
	// Does it have a weapon wheel?
	// We're going to ASSUME that weapon wheels guns use ACS display
	if (WeaponList[WI].useWheel)
	{
		InvEnsure("UseACSAmmoDisplay", 1);
		InvEnsure("CanUseWheel", 1);
		ACS_NamedExecuteAlways(WeaponList[WI].wheelScript,0,0,0,0);
	}
	else
	{
		InvEnsure("UseACSAmmoDisplay", 0);
		InvEnsure("CanUseWheel", 0);
	}
}

// This sets the HUD firing mode for the weapon we have selected
// This is not the ACTUAL firing mode, just the VISUAL firing mode
void ApplyFiringMode(str wep)
{
	int FM = 0;
	
	int WI = WeaponByType(wep);
	if (WI >= 0)
		FM = WeaponList[WI].fireMode;
		
	str FMI = WeaponList[WI].fireModeItem;
		
	
	switch (FM)
	{
		// Single / Full-Auto: Switchable
		case FM_SINGLEAUTO:
			// Semi-Automatic
			if (CheckInventory(FMI))
				FM = FM_SINGLE;
			else
				FM = FM_AUTO;
		break;
		
		// Single / Full-Auto (Shotgun)
		case FM_SHOTSINGLEAUTO:
			// Semi-Automatic
			if (CheckInventory(FMI))
				FM = FM_SHOTSINGLE;
			else
				FM = FM_SHOTAUTO;
		break;
		
		// Single / Burst
		case FM_SINGLEBURST:
			// Semi-Automatic
			if (CheckInventory(FMI))
				FM = FM_SINGLE;
			else
				FM = FM_BURST;
		break;
	}
		
	TakeInventory("BaseFireMode", 99);
	GiveInventory("BaseFireMode", FM);
}

script "GetCrosshair" (void)
{
	str wep = GetWeapon();
	ApplyFiringMode(wep);
	
	// Iron sights means NO crosshair
	if (CheckInventory("InIronSights"))
	{
		SetResultValue(20);
		terminate;
	}
	
	int WI = WeaponByType(wep);
	if (WI == -1)
	{
		SetResultValue(0);
		terminate;
	}
	
	// Do we even have a fire mode item?
	if (StrLen(WeaponList[WI].fireModeItem) <= 0)
		SetResultValue(WeaponList[WI].crosshairs[0]);
	else
	{
		int CH = CheckInventory(WeaponList[WI].fireModeItem);
		SetResultValue(WeaponList[WI].crosshairs[CH]);
	}
}

// This ACTUALLY SWITCHES our fire mode
// Also updates the HUD fire mode
script "FireModeSwitch" (void)
{
	str wep = GetWeapon();
	int WI = WeaponByType(wep);
	if (WI == -1)
		terminate;
		
	int valid = false;
	int FM = WeaponList[WI].fireMode;
	str FMI = WeaponList[WI].fireModeItem;
		
	// Based on our fire mode...
	switch (FM)
	{
		// Semi-Auto / Full-Auto
		case FM_SINGLEBURST:
		case FM_SINGLEAUTO:
		case FM_SHOTSINGLEAUTO:
			valid = true;
			if (CheckInventory(FMI))
				TakeInventory(FMI, 1);
			else
				GiveInventory(FMI, 1);
		break;
	}
	
	if (!valid)
		terminate;
		
	ApplyFiringMode(wep);	
	
	str FMName = FireModeNames[ CheckInventory("BaseFireMode") ];
	Print(s:"\cJSwitched to \cK", s:FMName);
}

script "LastWeapon" (void) net { SwitchToLast(); }

void SwitchToLast()
{
    int pn = PlayerNumber();
    SetWeapon(lastWeapon[pn]);
}